/*********************************************************************************
**
**   $Id: wopartsentry.ui.h,v 1.3 2004/05/27 11:44:07 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qmessagebox.h>

void WOPartsEntry::initialize()
{
   woPartsTable1->refresh();
   woPartsTable1->selectRow(0);
   woPartsForm1->descrEdit->setFocus();
//   updateBtn->setEnabled(false);
//   deleteBtn->setEnabled(false);
   accel = new QAccel(this);
   accel->connectItem( accel->insertItem(Key_Shift+Key_F10),
                       this,
                       SLOT(lookupInventory()) );
}

void WOPartsEntry::accept()
{
   woPartsForm1->updateRecord();
   woPartsForm1->commitTransaction();
   done(woPartsForm1->getLastIdent().toInt());
}

void WOPartsEntry::reject()
{
   if ( woPartsForm1->isInTransaction())
   {
      if (QMessageBox::warning(this, "Discarding Changes", 
                                "Canceling this will discard <b>ALL</b> of your changes. Are you sure you want to continue?",
                                QMessageBox::Yes, QMessageBox::No) == QMessageBox::Yes)
      {
         woPartsForm1->rollbackTransaction();
         done(QDialog::Rejected);
      }
   }
   else 
   {
      done(QDialog::Rejected);
   }
}


void WOPartsEntry::updateRecord()
{
   woPartsForm1->updateRecord();
   woPartsForm1->descrEdit->setFocus();
}

void WOPartsEntry::insertRecord()
{
   woPartsForm1->insertRecord();
   woPartsForm1->descrEdit->setFocus();
//   updateBtn->setEnabled(true);
//   deleteBtn->setEnabled(true);
}

void WOPartsEntry::deleteRecord()
{
   woPartsForm1->deleteRecord();
   woPartsForm1->descrEdit->setFocus();
//   updateBtn->setEnabled(false);
//   deleteBtn->setEnabled(false);
}


void WOPartsEntry::lookupInventory()
{
   PartsEdit *pe = new PartsEdit(this);
   int iPart = pe->exec();
   printf("WOPartsEntry::lookupInventory(): part selected: %d\n", iPart);
   if ( iPart > 0 ) 
   {
      QString sPart;
      sPart.setNum(iPart);
      QString sql = "select pn, retail, supply, descr from parts where ident = '" + sPart + "'";
      printf("WOPartsEntry::lookupInventory(): sql = |%s|\n", (const char*)sql);
      QSqlQuery q(sql);
      if ( q.isActive() && q.next() ) 
      {
         printf("WOPartsEntry::lookupInventory(): found part, inserting record\n");
         woPartsForm1->insertRecord();
         woPartsForm1->pnEdit->setText(q.value(0).toString());
         woPartsForm1->costEdit->setText(q.value(1).toDouble());
         woPartsForm1->supplySelect->setText(q.value(2).toString());
         woPartsForm1->descrEdit->setText(q.value(3).toString());
         woPartsForm1->taxableSelect->setText("Y");
         woPartsForm1->qtyEdit->setText("1");
         woPartsForm1->descrEdit->setFocus();
         woPartsForm1->setEnabled(true);
//         updateBtn->setEnabled(true);
//         deleteBtn->setEnabled(true);
      }
   }
}


void WOPartsEntry::keyPressEvent( QKeyEvent * e )
{
   printf("WOPartsEntry::keyPressEvent(): Entry, have key press for %s\n", e->text().isNull() == true ? "NULL" : (const char*)e->text());
   if ( e->key() == Qt::Key_Escape ) 
   {
      e->accept();
      done(QDialog::Rejected);
   }
   printf("WOPartsEntry::keyPressEvent(): Exit\n");
}
